#include <iostream>
#include <cstdio>
#include <set>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
    freopen("diagram.in", "r", stdin);
    freopen("diagram.out", "w", stdout);

    int n, k;
    cin >> n >> k;
    k = min(k + 1, n);
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<vector<ll> > b(n, vector<ll>(n));
    for (int i = 0; i < n; i++) {
        multiset<int> st1, st2; // st1 <= st2, sz(s1) <= sz(st2)
        ll sum1 = 0, sum2 = 0;
        for (int j = i; j < n; j++) {
            st2.insert(a[j]);
            sum2 += a[j];
            if ((int)st2.size() - (int)st1.size() > 1) {
                int x = *st2.begin();
                st2.erase(st2.begin());
                sum2 -= x;
                sum1 += x;
                st1.insert(x);
            }
            if (j != i) {
                while (1) {
                    multiset<int> :: iterator it = st1.end();
                    --it;
                    int a1 = *it;
                    int a2 = *st2.begin();
                    if (a1 > a2) {
                        st1.erase(it);
                        st2.erase(st2.begin());
                        sum1 += -a1 + a2;
                        sum2 += a1 - a2;
                        st1.insert(a2);
                        st2.insert(a1);
                    } else break;
                }
            }
            int median = *st2.begin();
            b[i][j] = (sum2 - 1LL * st2.size() * median) + (1LL * median * st1.size() - sum1);
            //cerr << b[i][j] << " \n"[j + 1 == n];
        }
    }

    vector<vector<ll> > dp(n + 1, vector<ll>(k + 1, 1e18));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            for (int l = i; l < n; l++) {
                dp[l + 1][j + 1] = min(dp[l + 1][j + 1], dp[i][j] + b[i][l]);
            }
        }
    }
    cout << dp[n][k] << endl;

    return 0;
}