import java.io.*;
import java.util.*;




public class divisors_ez {
    static class SegmentTree {
        class Tree {
            int l, r;
            ArrayList<Integer> val;
            public Tree(int l, int r) {
                this.l = l;
                this.r = r;
                val = makeList();               
            }           
        }
        ArrayList<Integer> sum(ArrayList<Integer> a, ArrayList<Integer> b) {
            ArrayList<Integer> ans = new ArrayList<Integer>();
            for (int i = 0; i < primes.size(); i++)
                ans.add(a.get(i) + b.get(i));
            return ans;
        }
        ArrayList<Tree> t;
        private void build(int v, int l, int r) {
            t.set(v, new Tree(l, r));
            if (r - l == 1)
                return;
            int m = (l + r) / 2;
            build(2 * v, l, m);
            build(2 * v + 1, m, r);         
        }       
        public SegmentTree(int n) {
            t = new ArrayList<Tree>();
            for (int i = 0; i < 4 * n; ++i)
                t.add(null);
            build(1, 0, n);         
        }
        public void insert(int v, int pos, ArrayList<Integer> val) {
            if (t.get(v).l > pos || t.get(v).r <= pos)
                return;
            if (t.get(v).l == pos && t.get(v).r == pos + 1) {
                t.get(v).val = val;
                return;
            }                       
            insert(2 * v, pos, val);
            insert(2 * v + 1, pos, val);
            t.get(v).val = sum(t.get(2 * v).val, t.get(2 * v + 1).val);
        }
        public ArrayList<Integer> get(int v, int l, int r) {
            if (t.get(v).l >= r || t.get(v).r <= l) {
                return makeList();  
            }
            if (t.get(v).l >= l && t.get(v).r <= r)
                return t.get(v).val;
            return sum(get(2 * v, l, r), get(2 * v + 1, l, r));
        }
    }

    private static ArrayList<Integer> primes;

    private static ArrayList<Integer> makeList() {
        ArrayList<Integer> ans = new ArrayList<Integer>();
        for (int i = 0; i < primes.size(); i++)
            ans.add(0);
        return ans;
    }

    private static ArrayList<Integer> factorizate(int a) {
        ArrayList<Integer> p = makeList();
        for (int i = 0; i < primes.size(); i++) {
            int now = 0;
            while (a % primes.get(i) == 0) {
                a /= primes.get(i);
                now++;
            }
            p.set(i, now);
        }
        return p;
    }       
    public static int calc(ArrayList<Integer> t) {
        long ans = 1;
        for (int i = 0; i < t.size(); i++) {
            ans = ans * (t.get(i) + 1);
            ans %= 1000000009;
        }
        return (int)ans;             
    }


    public static void main(String[] args) throws Exception {
        primes = new ArrayList<Integer>();
        for (int i = 2; i <= 10000; i++) {
            boolean prime = true;
            for (int j = 2; j < (int)Math.sqrt(i) + 1; j++)
                if (i % j == 0) 
                    prime = false;
            if (prime) 
                primes.add(i);
        }
        Scanner in = new Scanner(new File("divisors.in"));
        PrintWriter out = new PrintWriter(new File("divisors.out"));
        int n = in.nextInt();
        SegmentTree tree = new SegmentTree(n);
        for (int i = 0; i < n; i++)
            tree.insert(1, i, factorizate(in.nextInt()));
        int m = in.nextInt();           
        for (int it = 0; it < m; it++) {
            int a = in.nextInt();
            int b = in.nextInt();
            int c = in.nextInt();
            if (a == 0) 
                tree.insert(1, b - 1, factorizate(c));
            else
                out.println(calc(tree.get(1, b - 1, c)));           
        }
        out.close();
    }

}


