#include <iostream>
#include <cstdio>
#include <memory.h>
#include <map>

using namespace std;

typedef long long ll;

map<ll, int> fact(ll x) {
    map<ll, int> res;
    for (int i = 2; 1LL * i * i <= x; i++) {
        while (x % i == 0) {
            res[i]++;
            x /= i;
        }
    }
    if (x > 1) {
        res[x]++;
    }
    return res;
}

map<ll, int> both(map<ll, int> a, map<ll, int> b) {
    map<ll, int> res;
    for (map<ll, int> :: iterator it = a.begin(); it != a.end(); it++) {
        if (b.count(it->first)) {
            res[it->first] += min(a[it->first], b[it->first]);
        }
    }
    return res;
}

int dp[60][60][60];

int get(int n, int m, int k) {
    if (dp[n][m][k] != -1) return dp[n][m][k];
    if (n == 0 && m == 0 && k == 0) return dp[n][m][k] = 0;
    dp[n][m][k] = 0;
    for (int i = 1; i <= n - m; i++) {
        dp[n][m][k] |= !get(n - i, m, k);
    }
    for (int i = 1; i <= m; i++) {
        dp[n][m][k] |= !get(n - i, m - i, k - i);
    }
    for (int i = 1; i <= k - m; i++) {
        dp[n][m][k] |= !get(n, m, k - i);
    }   
    return dp[n][m][k];
}

int main() {
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    ll a, b;
    cin >> a >> b;
    map<ll, int> mpa = fact(a);
    map<ll, int> mpb = fact(b);
    map<ll, int> mpc = both(mpa, mpb);
    
    int k1 = 0, k2 = 0, k3 = 0;
    for (map<ll, int> :: iterator it = mpa.begin(); it != mpa.end(); it++) k1 += it->second;
    for (map<ll, int> :: iterator it = mpb.begin(); it != mpb.end(); it++) k2 += it->second;
    for (map<ll, int> :: iterator it = mpc.begin(); it != mpc.end(); it++) k3 += it->second;
                  
    memset(dp, -1, sizeof(dp));                                                           
    cout << (get(k1, k3, k2) ? "Lucky wins" : "Alf wins") << endl;

    //for (int i = 0; i <= k1; i++) for (int j = 0; j <= k3; j++) for (int k = 0; k <= k2; k++) if (min(i, k) >= j) cout << i << " " << j << " " << k << " " << get(i, j, k) << endl;

    return 0;
}