#include <iostream>
#include <cstdio>
#include <vector>
#include <memory.h>

using namespace std;

const int maxn = 1 << 17;

int n, m;
vector<int> e[maxn], g[maxn];
int tmr, in[maxn], out[maxn];
bool vis[maxn];

void dfs(int v, int p) {
	if (vis[v]) return;
	vis[v] = 1;
	in[v] = out[v] = tmr++;
	for (int i = 0; i < (int)e[v].size(); i++) {
	 	int to = e[v][i];
		if (to == p) continue;
		if (vis[to]) {
			out[v] = min(out[v], in[to]);
		} else {
		 	dfs(to, v);
			out[v] = min(out[v], out[to]);
			if (out[to] > in[v]) {
			 	g[v].push_back(to);
				g[to].push_back(v);
			}
		}
	}
}

int dfs2(int v) {
 	if (vis[v]) return 0;
	int res = 1;
	vis[v] = 1;
	for (int i = 0; i < (int)g[v].size(); i++) res += dfs2(g[v][i]);
	return res;
}

int main() {
	freopen("graph.in", "r", stdin);
	freopen("graph.out", "w", stdout);

	cin >> n >> m;
	for (int i = 0; i < m; i++) {
	 	int u, v;
		cin >> u >> v;
		e[u].push_back(v);
		e[v].push_back(u);
	}
	for (int i = 1; i <= n; i++) {
	 	dfs(i, -1);
	}
	memset(vis, 0, sizeof(vis));
	long long ans = 0;
	for (int i = 1; i <= n; i++) if (!vis[i]) {
	 	int cnt = dfs2(i);
		ans += 1LL * (cnt - 1) * (cnt - 2) / 2;
	}
	cout << ans << endl;

	return 0;
}