import random
random.seed("basic03")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(4, [(0, 0), (0, 1), (1, 1), (1, 0)], [(2, 4), (1, 3), (2, 4), (3, 1)])
        
    def generate_min_tests(self):
        self.print_test(4, [(0, 0), (0, 1), (1, 1), (1, 0)], [(2, 4), (1, 3), (2, 4), (1, 3)])
        self.print_test(3, [(0, 0), (0, 1), (1, 0)], [(2, 3), (1, 3), (1, 2)])
        self.print_test(3, [(-10, -10), (10, 10), (10, 0)], [(2, 3), (1, 3), (1, 2)])
                                                                    
    def generate_hand_tests(self):
        self.print_test(4, [(0, 0), (1, 1), (1, 0), (0, 1)], [(2, 4), (1, 3), (2, 4), (1, 3)])
        self.print_test(6, [(1, 1), (4, 1), (5, 7), (0, 8), (7, 4), (-1, 4)], [(2, 6), (5, 1), (5, 4), (3, 6), (2, 3), (4, 1)])
        n = 12
        ps = [(1, 0), (5, 7), (13, 7), (20, 0), (-1, 12), (5, 5), (12, 5), (18, 12), (0, 3), (0, 9), (4, 3), (4, 9)]
        graph = [(2, 4), (1, 3), (2, 4), (1, 3), (6, 8), (5, 7), (6, 8), (5, 7), (10, 12), (9, 11), (10, 12), (9, 11)]
        self.print_test(n, ps, graph)                                                            

    def generate_random_test(self, maxn, maxx):
        n = maxn
        ps = []
        for i in range(n):
            x = random.randint(-maxx, maxx)
            y = random.randint(-maxx, maxx)
            ps.append((x, y))
        cycles = random.randint(1, n // 3)
        p = [0 for i in range(n)]
        for i in range(n):
            p[i] = i + 1
        random.shuffle(p)
        c = [[] for i in range(cycles)]
        cs = 0
        for i in range(0, cycles * 3, 3):
            c[cs].append(p[i])
            c[cs].append(p[i + 1])
            c[cs].append(p[i + 2])
            cs += 1
        for i in range(cycles * 3, n):
            x = random.randint(0, cycles - 1)
            c[x].append(p[i])
        graph = [(0, 0) for i in range(n)]
        for i in range(cycles):
            for j, element in enumerate(c[i]):
                graph[element - 1] = (c[i][(j + 1) % len(c[i])], c[i][(j - 1 + len(c[i])) % len(c[i])])
        self.print_test(n, ps, graph)
                
    def generate_max_tests(self, maxn):
        n = maxn
        ps = []
        for i in range(n):
            x = random.randint(-10**9, 10**9)
            y = random.randint(-10**9, 10**9)
            ps.append((x, y))
        p = [0 for i in range(n)]
        for i in range(n):
            p[i] = i + 1
        random.shuffle(p)
        graph = [(0, 0) for i in range(n)]
        for i in range(n):
            graph[p[i] - 1] = (p[(i - 1 + n) % n], p[(i + 1) % n])
        self.print_test(n, ps, graph)

        random.shuffle(p)
        graph = [(0, 0) for i in range(n)]
        for i in range(0, n, 4):
            graph[p[i] - 1] = (p[i + 3], p[i + 1])
            graph[p[i + 1] - 1] = (p[i], p[i + 2])
            graph[p[i + 2] - 1] = (p[i + 1], p[i + 3])
            graph[p[i + 3] - 1] = (p[i + 2], p[i])
        self.print_test(n, ps, graph)

        n = maxn
        ps = []
        addx = random.randint(-10, 10)
        addy = random.randint(-10, 10)
        ps.append([0, 0])
        nowx = 0
        nowy = 0
        for i in range(1, n // 4):
            nowx += random.randint(1, 100000)
            nowy += random.randint(-100000, -1)
            ps.append([nowx, nowy])
        for i in range(n // 4, n // 2):
            nowx += random.randint(1, 100000)
            nowy += random.randint(1, 100000)
            ps.append([nowx, nowy])
        for i in range(n // 2, (3 * n) // 4):
            nowx += random.randint(-100000, -1)
            nowy += random.randint(1, 100000)
            ps.append([nowx, nowy])
        for i in range((3 * n) // 4, n):
            nowx += random.randint(-100000, -1)
            nowy += random.randint(-100000, -1)
            ps.append([nowx, nowy])

        graph = [(0, 0) for i in range(n)]
        for i in range(n):
            graph[i] = ((i - 1 + n) % n + 1, (i + 1) % n + 1) 

        assert(len(ps) == n)
        points = []
        for i in range(len(ps)):
            points.append((ps[i][0] + addx, ps[i][1] + addy))
        self.print_test(n, points, graph)

        n = maxn
        ps = []
        addx = random.randint(-10, 10)
        addy = random.randint(-10, 10)
        ps.append([0, 0])
        nowx = 0
        nowy = 0
        for i in range(1, n // 4):
            nowx += random.randint(1, 100)
            nowy += random.randint(-100, -1)
            ps.append([nowx, nowy])
        for i in range(n // 4, n // 2):
            nowx += random.randint(1, 100)
            nowy += random.randint(1, 100)
            ps.append([nowx, nowy])
        for i in range(n // 2, (3 * n) // 4):
            nowx += random.randint(-100, -1)
            nowy += random.randint(1, 100)
            ps.append([nowx, nowy])
        for i in range((3 * n) // 4, n):
            nowx += random.randint(-100, -1)
            nowy += random.randint(-100, -1)
            ps.append([nowx, nowy])

        p = [0 for i in range(n)]
        for i in range(n):
            p[i] = i + 1
        random.shuffle(p)

        assert(len(ps) == n)
        points = []
        for i in range(len(ps)):
            points.append((ps[p[i] - 1][0] + addx, ps[p[i] - 1][1] + addy))

        graph = [(0, 0) for i in range(n)]
        for i in range(n):
            graph[p[i] - 1] = (p[(i - 1 + n) % n], p[(i + 1) % n]) 
        self.print_test(n, points, graph)

        n = maxn
        ps = []
        graph = [(0, 0) for i in range(n)]
        nowx = 1
        nowy = 1
        for i in range(1, n + 1, 4):
            x = nowx
            y = nowy
            ps.append((x, y))
            x = nowx + 1 
            y = nowy
            ps.append((x, y))
            x = nowx
            y = nowy + 1
            ps.append((x, y))
            x = nowx + 1
            y = nowy + 1
            ps.append((x, y))
            graph[i - 1] = (i + 3, i + 1)
            graph[i] = (i + 2, i)
            graph[i + 1] = (i + 3, i + 1)
            graph[i + 2] = (i, i + 2)
            nowx += 2
            nowy += random.randint(10000, 1000000)
        self.print_test(n, ps, graph)

    def print_test(self, n, ps, graph):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(n, file=test_file)
        print('\n'.join(' '.join(str(coordinate) for coordinate in point) for point in ps), file=test_file)
        print('\n'.join(' '.join(str(child) for child in vertex) for vertex in graph), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        maxn = 200

        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        self.print_test(4, [(0, 0), (1, 1), (1, 0), (0, 1)], [(2, 4), (1, 3), (2, 4), (1, 3)])
        for i in range(1, 5):
            self.generate_random_test(maxn, 10**9)
        for i in range(5):
            self.generate_random_test(maxn, 10**5)
        self.generate_max_tests(maxn)        

import os, shutil
if os.path.exists('../tests'):
    print('Directory tests is already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)