import java.math.*;
import java.util.*;

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {

    ArrayDeque<Integer>[] a;

    int pop(int x) {
        if (x % 2 == 0) {
            return a[x].pollFirst();
        } else {
            return a[x].pollLast();
        }
    }

    void push(int x, int y) {
        a[x].addLast(y);
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
            int n = inf.nextInt();
            a = new ArrayDeque[2 * n + 1];
            for (int i = 0; i <= 2 * n; i++) {
                a[i] = new ArrayDeque<Integer>();
            }

            for (int i = 0; i < 1 << n; i++) {
                int x = inf.nextInt();
                a[0].addLast(x);
            }
            inf.close();

            for (int i = 0; i < 2 * n * (1 << n); i++) {
                int x = ouf.nextInt();
                if (x < 1 || x > 2 * n) {
                    return new Outcome(Type.WA, "b[" + Integer.toString(i + 1) + "] is out of range!");
                }
                x--;
                if (a[x].isEmpty()) {
                    return new Outcome(Type.WA, "error on " + Integer.toString(i + 1) + " operation: structure is empty");
                }
                int y = pop(x);
            //  System.out.println(y + ": " + x + " -> " + (x + 1));
                push(x + 1, y);
            }
            if (!ouf.seekEoF()) {
                return new Outcome(Type.WA, "too much tokens in answer");
            }
            boolean ok = true;
            for (int i = 1; i <= 1 << n; i++) {
                int x = pop(n * 2);
                //System.out.print(x + " ");
                ok &= x == i;
            }
            //System.out.println();
            if (!ok) {
                return new Outcome(Type.WA, "sequence is not sorted");
            }
            return new Outcome(Type.OK, "participant found good answer");
    }
}
